#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define ull unsigned long long
#define int long long

vector<int> a, pref, min1;

const int N = 3e5 + 500;
int d[N * 4], p[N * 4], d1[N * 4];

void build(int v, int l, int r) {
    p[v] = -1;
    if (l == r) {
        d[v] = pref[l] + min1[l];
        d1[v] = pref[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    d1[v] = min(d1[2 * v], d1[2 * v + 1]);
    d[v] = min(d[2 * v], d[2 * v + 1]);
}

void push(int v) {
    if (p[v] != -1) {
        d[2 * v] = d1[2 * v] + p[v];
        d[2 * v + 1] = d1[2 * v + 1] + p[v];
        p[2 * v] = p[v];
        p[2 * v + 1] = p[v];
        p[v] = -1;
    }
}

void update(int v, int l, int r, int x, int y, int zn) {
    if (l > y || x > r) {
        return;
    }
    if (l >= x && r <= y) {
        d[v] = d1[v] + zn;
        p[v] = zn;
        return;
    }
    int m = (l + r) / 2;
    push(v);
    update(2 * v, l, m, x, y, zn);
    update(2 * v + 1, m + 1, r, x, y, zn);
    d[v] = min(d[2 * v], d[2 * v + 1]);
}

int find_ans(int v, int l, int r, int x, int y) {
    if (l > y || x > r) {
        return 1e18;
    }
    if (l >= x && r <= y) {
        return d[v];
    }
    int m = (l + r) / 2;
    push(v);
    return min(find_ans(2 * v, l, m, x, y), find_ans(2 * v + 1, m + 1, r, x, y));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k;
    cin >> n >> k;
    a.resize(n + 1);
    pref.resize(n + 1);
    min1.resize(n + 1);
    min1[0] = 2e9;
    a[0] = 2e9;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
        min1[i] = min(a[i], min1[i - 1]);
    }
    int d = n - k + 1, ans = 0;
    build(1, 0, n);
    for (int i = n; i >= 1; --i) {
        ans = max(ans, pref[i] - find_ans(1, 0, n, max(0ll, i - d), i - 1));
        int l = -1, r = i;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (min1[mid] > a[i]) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (l != -1) {
            update(1, 0, n, 0, l, a[i]);
        }
    }
    cout << ans;
    return 0;
}
