#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define ull unsigned long long
// #define int long long

const int N = 1e5 + 10;

vector<vector<int>> dp[N];
vector<int> pred[N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, s;
    cin >> n >> s;
    vector<vector<int>> a(n), g(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        a[i].resize(m);
        dp[i].resize(2, vector<int>(s + 1));
        dp[i][0][0] = 1;
        pred[i].resize(s + 1, -1);
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            for (int k = 0; k <= s; ++k) {
                dp[i][1][k] = 0;
                if (dp[i][0][k]) {
                    dp[i][1][k] = 1;
                    continue;
                }
                if (a[i][j] <= k && dp[i][0][k - a[i][j]]) {
                    dp[i][1][k] = 1;
                    pred[i][k] = j + 1;
                }
            }
            swap(dp[i][0], dp[i][1]);
        }
        for (int k = 1; k <= s; ++k) {
            if (dp[i][0][k]) {
                g[i].pb(k);
            }
        }
    }
    vector<vector<int>> r(2, vector<int>(s + 1));
    vector<int> prev(s + 1, -1);
    r[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k <= s; ++k) {
            r[1][k] = 0;
        }
        for (int j : g[i]) {
            for (int k = 0; k <= s; ++k) {
                if (k >= j && r[0][k - j]) {
                    r[1][k] = 1;
                    prev[k] = j;
                }
            }
        }
        swap(r[0], r[1]);
    }
    if (!r[0][s]) {
        cout << "No";
    } else {
        cout << "Yes\n";
        vector<int> g1(n);
        for (int i = n - 1; i >= 0; i--) {
            g1[i] = prev[s];
            s = s - prev[s];
        }
        for (int i = 0; i < n; ++i) {
            vector<int> ans;
            while (g1[i] > 0) {
                ans.pb(pred[i][g1[i]]);
                g1[i] = g1[i] - a[i][pred[i][g1[i]] - 1];
            }
            cout << sz(ans) << "\n";
            for (int j : ans) {
                cout << j << " ";
            }
            cout << "\n";
        }
    }
    return 0;
}
