#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define ull unsigned long long
#define int long long

const int N = 4e6 + 1, mod = 1e9 + 7;
int fact[N], f1[N];
vector<vector<int> > was, used;
vector<pair<int, int> > a;
int n, m, k, ans = 0;

int skor(int a, int st) {
    int ans = 1;
    while (st) {
        if (st & 1) {
            ans *= a;
            ans %= mod;
        }
        a *= a;
        a %= mod;
        st >>= 1;
    }
    return ans;
}

int inv(int x) {
    return skor(x, mod - 2);
}

int c(int n, int k) {
    return fact[n] * f1[k] % mod * f1[n - k] % mod;
}

int sum(int a, int b) {
    if (a + b >= mod) {
        return a + b - mod;
    }
    return a + b;
}

bool prov(int x, int y, int sum) {
    return (x >= 1 && x <= n && y >= 1 && y <= m && !used[x][y]) || (x == 1 && y == 1 && sum == 2 * n + 2 * m - 5);
}

void rec(int sum, int x, int y, int kol) {
    if (sum == n + m - 2 && !(x == n && y == m)) {
        return;
    }
    if (sum == 2 * n + 2 * m - 4 && x == 1 && y == 1 && kol == k) {
        ans++;
        return;
    } else if (sum >= 2 * n + 2 * m - 4) {
        return;
    }
    if (was[x][y]) {
        kol++;
    }
    used[x][y] = 1;
    if (prov(x - 1, y, sum)) {
        rec(sum + 1, x - 1, y, kol);
    }
    if (prov(x + 1, y, sum)) {
        rec(sum + 1, x + 1, y, kol);
    }
    if (prov(x, y - 1, sum)) {
        rec(sum + 1, x, y - 1, kol);
    }
    if (prov(x, y + 1, sum)) {
        rec(sum + 1, x, y + 1, kol);
    }
    used[x][y] = 0;
    if (was[x][y]) {
        kol--;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
    f1[N - 1] = inv(fact[N - 1]);
    for (int i = N - 2; i >= 0; i--) {
        f1[i] = f1[i + 1] * (i + 1) % mod;
    }
    cin >> n >> m >> k;
    a.resize(k);
    was.resize(n + 1, vector<int>(m + 1));
    used.resize(n + 1, vector<int>(m + 1));
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        was[a[i].first][a[i].second] = 1;
    }
    if (n <= 8 && m <= 8 && k <= 8) {
        rec(0, 1, 1, 0);
    } else if (n == 3 && m <= 100 && k <= 100) {
        for (int i = 1; i <= m; ++i) {
            for (int j = 1; j < i; ++j) {
                bool was = false;
                for (auto f: a) {
                    if (f.first == 1) {
                        if (f.second == 1) {
                            continue;
                        }
                        if (f.second > i) {
                            was = true;
                            break;
                        }
                    } else if (f.first == 2) {
                        if (f.second > j && f.second < i) {
                            was = true;
                            break;
                        }
                    } else {
                        if (f.second == m) {
                            continue;
                        }
                        if (f.second < j) {
                            was = true;
                            break;
                        }
                    }
                }
                if (!was) {
                    ans++;
                }
            }
        }
        ans *= 2;
    }
    cout << ans;
    return 0;
}
