#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define sz(x) (int) x.size()
#define pb push_back
// #define int long long

vector<int> a;
const int N = 4e5 + 1000, f = 20;

int s[N], sp[f][N / 4], st[N / 4];
ll l1[N], r1[N], pl[N], pr[N];
pair<int, int> max1[N], max2[N];

void push(int v, int l, int r) {
    int m = (l + r) / 2;
    if (pl[v] != 0) {
        l1[2 * v] = (m - l + 1) * pl[v];
        l1[2 * v + 1] = (r - m) * pl[v];
        pl[2 * v] = pl[v];
        pl[2 * v + 1] = pl[v];
        pl[v] = 0;
    }
    if (pr[v] != 0) {
        r1[2 * v] = (m - l + 1) * pr[v];
        r1[2 * v + 1] = (r - m) * pr[v];
        pr[2 * v] = pr[v];
        pr[2 * v + 1] = pr[v];
        pr[v] = 0;
    }
}
void builda(int v, int l, int r) {
    if (l == r) {
        max1[v] = {a[l], l};
        max2[v] = {a[l], l};
        l1[v] = a[l];
        r1[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    builda(2 * v, l, m);
    builda(2 * v + 1, m + 1, r);
    max1[v] = max1[2 * v + 1];
    if (max1[2 * v].first >= max1[2 * v + 1].first) {
        max1[v] = max1[2 * v];
    }
    max2[v] = max2[2 * v];
    if (max2[2 * v + 1].first >= max2[2 * v].first) {
        max2[v] = max2[2 * v + 1];
    }
    l1[v] = l1[2 * v] + l1[2 * v + 1];
    r1[v] = r1[2 * v] + r1[2 * v + 1];
}

pair<int, int> find_max(int v, int l, int r, int x, int y, int type) {
    if (l > y || x > r) {
        return {-1, -1};
    }
    if (l >= x && r <= y) {
        if (type == 1) {
            return max1[v];
        }
        return max2[v];
    }
    int m = (l + r) / 2;
    auto v1 = find_max(2 * v, l, m, x, y, type), v2 = find_max(2 * v + 1, m + 1, r, x, y, type);
    if (v1.first > v2.first) {
        return v1;
    } else if (v2.first > v1.first) {
        return v2;
    } else {
        if (type == 1) {
            return v1;
        } else {
            return v2;
        }
    }
}

void update(int v, int l, int r, int x, int y, ll zn, int type) {
    if (l > y || x > r) {
        return;
    }
    if (l >= x && r <= y) {
        if (type == 1) {
            l1[v] = zn * (r - l + 1);
            pl[v] = zn;
        } else {
            r1[v] = zn * (r - l + 1);
            pr[v] = zn;
        }
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    update(2 * v, l, m, x, y, zn, type);
    update(2 * v + 1, m + 1, r, x, y, zn, type);
    if (type == 1) {
        l1[v] = l1[2 * v] + l1[2 * v + 1];
    } else {
        r1[v] = r1[2 * v] + r1[2 * v + 1];
    }
}

ll find_sum(int v, int l, int r, int x, int y, int type) {
    if (l > y || x > r || x > y) {
        return 0;
    }
    if (l >= x && r <= y) {
        if (type == 1) {
            return l1[v];
        }
        return r1[v];
    }
    push(v, l, r);
    int m = (l + r) / 2;
    return find_sum(2 * v, l, m, x, y, type) + find_sum(2 * v + 1, m + 1, r, x, y, type);
}

void builds(int v, int l, int r) {
    s[v] = r - l + 1;
    if (l == r) {
        return;
    }
    int m = (l + r) / 2;
    builds(2 * v, l, m);
    builds(2 * v + 1, m + 1, r);
}

void updates(int v, int l, int r, int pos) {
    s[v]--;
    if (l == r) {
        return;
    }
    int m = (l + r) / 2;
    if (pos > m) {
        updates(2 * v + 1, m + 1, r, pos);
    } else {
        updates(2 * v, l, m, pos);
    }
}

int find_k(int v, int l, int r, int k) {
    if (l == r) {
        return l;
    }
    int m = (l + r) / 2;
    if (s[2 * v] < k) {
        return find_k(2 * v + 1, m + 1, r, k - s[2 * v]);
    }
    return find_k(2 * v, l, m, k);
}

int find_ans(int l, int r) {
    return max(sp[st[r - l + 1]][l], sp[st[r - l + 1]][r - (1 << st[r - l + 1]) + 1]);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    a.resize(n);
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = a[i] + pref[i];
    }
    for (int i = 1; i <= n + 1; ++i) {
        st[i] = st[i - 1];
        if (i > (1 << (st[i] + 1))) {
            st[i]++;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        sp[0][i] = a[i];
        for (int j = 1; j < f; ++j) {
            sp[j][i] = max(sp[j - 1][i], sp[j - 1][min(n - 1, sp[j - 1][i + (1 << (j - 1))])]);
        }
    }
    builda(1, 0, n - 1);
    builds(1, 0, n);
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        int l1 = find_k(1, 0, n, x), l2 = find_k(1, 0, n, x + 1), r1 = l2 - 1, r2 = find_k(1, 0, n, x + 2) - 1;
        updates(1, 0, n, l2);
        auto v1 = find_max(1, 0, n - 1, l1, r1, 2), v2 = find_max(1, 0, n - 1, l2, r2, 1);
        ll ans = 0;
        if (v2.first >= v1.first) {
            update(1, 0, n - 1, l1, r1, v2.first, 2);
            int l = l2 - 1, r = r2 + 1;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (find_ans(l2, mid) >= v1.first) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            if (l != l2 - 1) {
                update(1, 0, n - 1, l2, l, v1.first, 1);
            }
            ans = find_sum(1, 0, n - 1, l1, v2.second - 1, 1) + find_sum(1, 0, n - 1, v2.second, r2, 2);
        } else {
            update(1, 0, n - 1, l2, r2, v1.first, 1);
            int l = l1 - 1, r = r1 + 1;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (find_ans(mid, r1) >= v2.first) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (r != r1 + 1) {
                update(1, 0, n - 1, r, r1, v2.first, 2);
            }
            ans = find_sum(1, 0, n - 1, l1, v1.second - 1, 1) + find_sum(1, 0, n - 1, v1.second, r2, 2);
        }
        ans -= pref[r2 + 1] - pref[l1];
        cout << ans << "\n";
    }
    return 0;
}
